private var surfaceMat: Material;
private var width:int = 300;
private var height:int = 300;
private var texture: Texture2D;
private var cells = new Array(width*height);
private var emptyCellColor: Color = new Color(0,0,0,0);
private var aliveCellColor: Color = new Color(1,1,1,1);

private var iteration = 0;

/*color r, g, b values will be used as population attributes
r = strength
g = fertility
b = chance of mutation */

function OnGUI()
{
	GUI.Button(Rect(160,40,120,30),"");
	GUI.Label(Rect(180,45,120,30),"Iteration: " + iteration);	
}

function Start()
{
	surfaceMat = this.renderer.material;
	texture = new Texture2D(width,height);
	
	//initialise all cells to empty/dead
	for (y=0; y < this.height; ++y) 
	{
		for (x=0; x < this.width; ++x) 
		{
			texture.SetPixel (x, y, emptyCellColor);
		}
	}
	
	//draw on surface
	surfaceMat.mainTexture = texture;
	texture.Apply();
	
	Seed();
}

function Seed()
{
	for(var i = 0; i < 5000; i++)
	{
		var pop = Color(Random.Range(0.0f,1.0f),Random.Range(0.0f,1.0f),Random.Range(0.0f,1.0f));
		texture.SetPixel(Random.Range(0,width),Random.Range(0,height), pop);
	}
	texture.Apply();	
}


function UpdateCell(x: int, y: int)
{
	if(texture.GetPixel(x,y) == emptyCellColor) return;
	
	//if chance of mutation
	if(Random.Range(0.0f,1.0f) < texture.GetPixel(x,y).b)
	{
		texture.SetPixel(x,y, Color(Random.Range(0.0f,1.0f),Random.Range(0.0f,1.0f),Random.Range(0.0f,1.0f)));
	}
	
	//if a neighbouring cell is empty expand into it
	if(Random.Range(0.0f,1.0f) < texture.GetPixel(x,y).g)
	{
		if(texture.GetPixel(x-1,y+1) == emptyCellColor) texture.SetPixel(x-1,y+1,texture.GetPixel(x,y));
		if(texture.GetPixel(x,y+1) == emptyCellColor) texture.SetPixel(x,y+1,texture.GetPixel(x,y));
		if(texture.GetPixel(x+1,y+1) == emptyCellColor) texture.SetPixel(x+1,y+1,texture.GetPixel(x,y));
		if(texture.GetPixel(x-1,y-1) == emptyCellColor) texture.SetPixel(x-1,y-1,texture.GetPixel(x,y));
		if(texture.GetPixel(x,y-1) == emptyCellColor) texture.SetPixel(x,y-1,texture.GetPixel(x,y));
		if(texture.GetPixel(x+1,y-1) == emptyCellColor) texture.SetPixel(x+1,y-1,texture.GetPixel(x,y));
		if(texture.GetPixel(x-1,y) == emptyCellColor) texture.SetPixel(x-1,y,texture.GetPixel(x,y));
		if(texture.GetPixel(x+1,y) == emptyCellColor) texture.SetPixel(x+1,y,texture.GetPixel(x,y));
	}
	
	//if a neighbour is stronger they overtake the cell
	if(texture.GetPixel(x-1,y+1).r < texture.GetPixel(x,y).r) texture.SetPixel(x-1,y+1,texture.GetPixel(x,y));
	if(texture.GetPixel(x,y+1).r  < texture.GetPixel(x,y).r) texture.SetPixel(x,y+1,texture.GetPixel(x,y));
	if(texture.GetPixel(x+1,y+1).r  < texture.GetPixel(x,y).r) texture.SetPixel(x+1,y+1,texture.GetPixel(x,y));
	if(texture.GetPixel(x-1,y-1).r  < texture.GetPixel(x,y).r) texture.SetPixel(x-1,y-1,texture.GetPixel(x,y));
	if(texture.GetPixel(x,y-1).r  < texture.GetPixel(x,y).r) texture.SetPixel(x,y-1,texture.GetPixel(x,y));
	if(texture.GetPixel(x+1,y-1).r  < texture.GetPixel(x,y).r) texture.SetPixel(x+1,y-1,texture.GetPixel(x,y));
	if(texture.GetPixel(x-1,y).r  < texture.GetPixel(x,y).r) texture.SetPixel(x-1,y,texture.GetPixel(x,y));
	if(texture.GetPixel(x+1,y).r  < texture.GetPixel(x,y).r) texture.SetPixel(x+1,y,texture.GetPixel(x,y));

	
	//if a neighbouring cell is 
}

function Update () 
{
	for(var i = 0; i < 5000; i++)
	{	
		UpdateCell(Random.Range(1,width-1),Random.Range(1,height-1));
	}
	texture.Apply();
	iteration++;
}